VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Letter Permutation Generator"
   ClientHeight    =   8100
   ClientLeft      =   60
   ClientTop       =   300
   ClientWidth     =   10170
   LinkTopic       =   "Form1"
   ScaleHeight     =   8100
   ScaleWidth      =   10170
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin VB.HScrollBar ScrollLess 
      Height          =   255
      Left            =   2520
      Max             =   5
      Min             =   1
      TabIndex        =   6
      Top             =   1680
      Value           =   5
      Width           =   2355
   End
   Begin VB.CheckBox CheckLess 
      Caption         =   "Use Less than whole word"
      Height          =   315
      Left            =   2520
      TabIndex        =   5
      Top             =   1320
      Value           =   1  'Checked
      Width           =   2715
   End
   Begin VB.TextBox TextCount 
      Height          =   315
      Left            =   2520
      TabIndex        =   3
      Text            =   "oo"
      Top             =   960
      Width           =   1335
   End
   Begin VB.TextBox TextWord 
      Height          =   315
      Left            =   2520
      TabIndex        =   0
      Text            =   "Moods"
      Top             =   240
      Width           =   1335
   End
   Begin VB.CommandButton CmdCount 
      Caption         =   "C&ount"
      Height          =   315
      Left            =   3900
      TabIndex        =   4
      Top             =   960
      Width           =   1335
   End
   Begin VB.CommandButton CmdReset 
      Caption         =   "&Reset"
      Height          =   315
      Left            =   3900
      TabIndex        =   1
      Top             =   240
      Width           =   1335
   End
   Begin VB.CommandButton CmdCalc 
      Caption         =   "&Calc"
      Height          =   315
      Left            =   2520
      TabIndex        =   2
      Top             =   600
      Width           =   2715
   End
   Begin VB.Label LabelLess 
      Caption         =   "5"
      Height          =   255
      Left            =   4920
      TabIndex        =   7
      Top             =   1680
      Width           =   315
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Function getDigit(base%, index%, want%)
         'a = Int(index / (FACT(base - 1) / FACT((UBound(word) + 1) - want))) Mod base
   getDigit = Int(index / (FACT(base - 1) / FACT((UBound(Word) + 1) - want))) Mod base
End Function
Private Function getWord(index%) As String
    Dim number%()
    Dim i%, lc%, numberTaken() As Boolean, i2%, a$
    ReDim number(ScrollLess - 1)
    ReDim numberTaken(UBound(Word))
    
    For i = 0 To UBound(number)
        number(i) = getDigit(i + UBound(Word) + 2 - ScrollLess, index, ScrollLess)
        a = a & number(i) & ","
    Next i
    For i = 0 To UBound(number)
        lc = 0
        For i2 = 0 To UBound(numberTaken)
            If Not numberTaken(i2) Then
                If lc = number(UBound(number) - i) Then Exit For
                lc = lc + 1
            End If
        Next i2
        getWord = getWord & Word(i2)
        numberTaken(i2) = True
    Next i
End Function

Private Sub CheckLess_Click()
    ScrollLess.Enabled = CheckLess
    If Not CheckLess Then ScrollLess = ScrollLess.Max
End Sub

Private Sub CmdCalc_Click()
    Dim i%, i2%, wrd$, list1$(), count%, match As Boolean
    Cls
    count = 0
    ReDim list1$(FACT(UBound(Word) + 1) / FACT(UBound(Word) + 1 - ScrollLess))
    For i = 0 To UBound(list1)
        list1$(count) = getWord(i)
        match = False
        If count > 0 Then
            For i2 = 0 To count - 1
                If list1(count) = list1(i2) And list1(i2) <> "" Then
                     match = True
                End If
            Next i2
        End If
        If Not match Then
            count = count + 1
        End If
    Next i
    ReDim List$(count - 1)
    Clipboard.Clear
    For i = 0 To count - 1
        List(i) = list1(i)
        Clipboard.SetText (Clipboard.GetText & List(i) & vbCr)
        Print List(i)
    Next i
    i = FACT(UBound(Word) + 1) / FACT(UBound(Word) + 1 - ScrollLess)
    wrd = ""
    wrd = wrd & "There are a united " & i & " different/identical " & ScrollLess & " letter versions of the word " & TheWord
    wrd = wrd & vbCr & vbCr & "There are a happy " & count & " different " & ScrollLess & " letter versions of the word " & TheWord
    wrd = wrd & vbCr & "There are a depressed " & i - count & " identical " & ScrollLess & " letter versions of the word " & TheWord
    wrd = wrd & vbCr & "The percentage of identical 'words' is " & Round(2, (i - count) / i * 100) & "%"
    wrd = wrd & vbCr & "The percentage of different 'words' is " & Round(2, (0 + count) / i * 100) & "%"
    MsgBox wrd$, vbInformation, "So there you go"
End Sub

Private Sub CmdCount_Click()
    Dim i%, listAdd$, count%
    For i = 0 To UBound(List)
        If InStr(List(i), UCase$(TextCount.Text)) Then listAdd$ = listAdd$ & List(i) & vbCr: count = count + 1
    Next i
    If count > 20 Then
        If MsgBox("The number of items is " & count & ", show list?", vbYesNo + vbExclamation, "Look down, fool.") = vbNo Then listAdd$ = ""
    End If
    MsgBox count & " items containing " & TextCount.Text & vbCr & listAdd
End Sub

Private Sub CmdReset_Click()
    setWord
End Sub

Private Sub Form_Load()
    setWord
End Sub
Private Sub setWord()
    Dim i%
    TheWord = UCase$(TextWord.Text)
    ReDim Word(Len(TheWord) - 1)
    ReDim List(Len(TheWord))
    For i = 0 To UBound(Word)
        Word(i) = Mid$(TheWord, i + 1, 1)
    Next i
    ScrollLess = ScrollLess.Min
    ScrollLess.Min = 1
    ScrollLess.Max = Len(TheWord)
    ScrollLess = ScrollLess.Max
    ScrollLess_Change
End Sub

Private Sub ScrollLess_Change()
    LabelLess = ScrollLess
End Sub
